Subscribe to real-time DTMF events

This code snippet registers a listener to receive asynchronous DTMF inputs from a call.

This is only applicable to Input NCCO events with the mode set to asynchronous.

Example

Replace the following variables in the example code:

KeyDescription
VOICE_CALL_ID

The UUID of the call leg.

VOICE_EVENT_URL

The URL (wrapped in an array) to send DTMF events to, as a POST request.

Prerequisites

Execute the following command at your terminal prompt to create the JWT for authentication:

export JWT=$(nexmo jwt:generate $PATH_TO_PRIVATE_KEY application_id=$NEXMO_APPLICATION_ID)

Write the code

Add the following to subscribe-dtmf-real-time-events.sh:

curl -X PUT https://api.nexmo.com/v1/calls/$VOICE_CALL_ID/input/dtmf \
  -H "Authorization: Bearer $JWT"\
  -H "Content-Type: application/json"\
  -d '{"event_url": "'"VOICE_EVENT_URL"'"}'

View full source

Run your code

Save this file to your machine and run it:

bash subscribe-dtmf-real-time-events.sh

Prerequisites

Add the following to build.gradle:

implementation 'com.vonage:server-sdk:9.3.1'

Create a file named SubscribeToDtmfEvents and add the following code to the main method:

VonageClient client = VonageClient.builder()
        .applicationId(VONAGE_APPLICATION_ID)
        .privateKeyPath(VONAGE_PRIVATE_KEY_PATH)
        .build();

View full source

Write the code

Add the following to the main method of the SubscribeToDtmfEvents file:

client.getVoiceClient().addDtmfListener(VOICE_CALL_ID, VOICE_EVENT_URL);

View full source

Run your code

We can use the application plugin for Gradle to simplify the running of our application. Update your build.gradle with the following:

apply plugin: 'application'
mainClassName = project.hasProperty('main') ? project.getProperty('main') : ''

Run the following gradle command to execute your application, replacing com.vonage.quickstart.voice with the package containing SubscribeToDtmfEvents:

gradle run -Pmain=com.vonage.quickstart.voice.SubscribeToDtmfEvents

Prerequisites

Install-Package Vonage

Write the code

Add the following to SubscribeDtmfRealTimeEvents.cs:

var credentials = Credentials.FromAppIdAndPrivateKeyPath(VONAGE_APPLICATION_ID, VONAGE_PRIVATE_KEY_PATH);
var client = new VonageClient(credentials);
await client.VoiceClient.SubscribeRealTimeDtmf(VOICE_CALL_ID, VOICE_EVENT_URL);

View full source